// LS/IF:  DepthAlpha

@version 2.0
@warnings
@script image

var camDOF;
var scene;
var ti;
var a;
var d;
var f;
ipc = 2;
cc = .036;

create
{
   setdesc("DOF to Alpha");
	camDOF = getfirstitem(CAMERA);
}

flags
{
   return (RED,GREEN,BLUE,ALPHA,DEPTH);
}

process: width, height, frame, starttime, endtime
{
	if(ipc == 1)
	{
		a = cam$fstop;
		f = cam$focallength;
		d = cam$focaldistance * 1000;
	}
	if(ipc == 2)
	{
		ti = frame / 30;
		a = camDOF.fStop(ti);
		f = camDOF.focalLength(ti);
		dd = camDOF.focalDistance(ti);
		d = dd * 1000;
	}

	nearDOF = ((d*f*f) / ((d*a*cc) + (f*f))) / 1000;
	farDOF = ((d*f*f) / ((d*a*cc) - (f*f))) / -1000;
	relBlurDist = farDOF * 2; // calculate roughly relBlurDist
   depth[width] = 0.0;

   moninit(height);

   for(i = 1;i <= height;++i)		//	 vert loop
   {
      red = bufferline(RED,i);
      green = bufferline(GREEN,i);
      blue = bufferline(BLUE,i);
      alpha = bufferline(ALPHA,i);
      depth = floatline(DEPTH,i);
      for(j = 1;j <= width;++j)		// horiz loop
      {
			if(depth[j]<= farDOF && depth[j]>=nearDOF)	// if the current pixel is WITHIN DOF		
				z = 0.0;
         if(depth[j]>farDOF)		//	if depth of current pixel is beyond DOF
				z = (depth[j] - farDOF) * (255.0 / (relBlurDist - farDOF));
			if(depth[j]<nearDOF)		// if depth is short
				z = (nearDOF - depth[j]) * (255.0 / nearDOF);
			if(z>255)
				z = 255.0;
			alpha[j] = integer(z);
      }

      processrgb(i,red,green,blue,alpha);

      if(monstep())
          return;
   }

   monend();
}

options
{
   if(!reqbegin("Depth Of Field To Alpha Channel"))
        return;

	c0 = ctlchoice("RackFocus IPC",ipc,@"Enable","Disable"@);
	c1 = ctlnumber("Circle of Confusion (in mm)",cc);
	cz = ctltext("Note:","ENABLING IPC support will disregard all values below");
	c2 = ctlcameraitems("Referring DOF settings",camDOF);

   if(reqpost())
   {
		ipc = getvalue(c0);
		cc = getvalue(c1);
		camDOF = getvalue(c2); 
   }

//	a = cam$fstop;
//	f = cam$focallength;
//	d = cam$focaldistance * 1000;
//	nearDOF = ((d*f*f) / ((d*a*.036) + (f*f))) / 1000;
//	farDOF = ((d*f*f) / ((d*a*.036) - (f*f))) / -1000;
//	info((farDOF - nearDOF));
//	relBlurDist = (((farDOF - nearDOF) * 2) + farDOF); // calculate roughly relBlurDist and convert to meters
//	info("focaldist ",d);
//	info("focallength ",f);
//	info("fstop ",a);
//	info("neardof ",nearDOF);
//	info("fardof ",farDOF);
//	info("relblurdist ",relBlurDist);
}


